package org.xdoclet.plugin.jdo.qtags;

public class JdoFieldTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.jdo.qtags.JdoFieldTag {
    public static final String NAME = "jdo.field";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"column",
		"default-fetch-group",
		"delete-action",
		"dependent",
		"embedded",
		"fetch-depth",
		"foreign-key",
		"indexed",
		"load-fetch-group",
		"mapped-by",
		"null-value",
		"persistence-modifier",
		"primary-key",
		"sequence",
		"serialized",
		"unique",
		"value-strategy",
		"table",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public JdoFieldTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public JdoFieldTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractBaseJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getColumn() {
		boolean required = false;
        String result = getNamedParameter("column");
        if(required && result == null) {
            bomb("column=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getDefaultFetchGroup() {
		boolean required = false;
        String result = getNamedParameter("default-fetch-group");
        if(required && result == null) {
            bomb("default-fetch-group=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getDeleteAction() {
		boolean required = false;
        String result = getNamedParameter("delete-action");
        if(required && result == null) {
            bomb("delete-action=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("restrict")|| result.equals("cascade")|| result.equals("null")|| result.equals("default")|| result.equals("none")) ) {
	                // todo we should say what file and line number too
	                bomb("delete-action=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getDependent() {
		boolean required = false;
        String result = getNamedParameter("dependent");
        if(required && result == null) {
            bomb("dependent=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.Boolean getEmbedded() {
		boolean required = false;
        String result = getNamedParameter("embedded");
        if(required && result == null) {
            bomb("embedded=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getFetchDepth() {
		boolean required = false;
        String result = getNamedParameter("fetch-depth");
        if(required && result == null) {
            bomb("fetch-depth=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getForeignKey() {
		boolean required = false;
        String result = getNamedParameter("foreign-key");
        if(required && result == null) {
            bomb("foreign-key=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getIndexed() {
		boolean required = false;
        String result = getNamedParameter("indexed");
        if(required && result == null) {
            bomb("indexed=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")|| result.equals("unique")) ) {
	                // todo we should say what file and line number too
	                bomb("indexed=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLoadFetchGroup() {
		boolean required = false;
        String result = getNamedParameter("load-fetch-group");
        if(required && result == null) {
            bomb("load-fetch-group=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMappedBy() {
		boolean required = false;
        String result = getNamedParameter("mapped-by");
        if(required && result == null) {
            bomb("mapped-by=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNullValue() {
		boolean required = false;
        String result = getNamedParameter("null-value");
        if(required && result == null) {
            bomb("null-value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("exception")|| result.equals("default")|| result.equals("none")) ) {
	                // todo we should say what file and line number too
	                bomb("null-value=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPersistenceModifier() {
		boolean required = false;
        String result = getNamedParameter("persistence-modifier");
        if(required && result == null) {
            bomb("persistence-modifier=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("persistent")|| result.equals("transactional")|| result.equals("none")) ) {
	                // todo we should say what file and line number too
	                bomb("persistence-modifier=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getPrimaryKey() {
		boolean required = false;
        String result = getNamedParameter("primary-key");
        if(required && result == null) {
            bomb("primary-key=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getSequence() {
		boolean required = false;
        String result = getNamedParameter("sequence");
        if(required && result == null) {
            bomb("sequence=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getSerialized() {
		boolean required = false;
        String result = getNamedParameter("serialized");
        if(required && result == null) {
            bomb("serialized=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.Boolean getUnique() {
		boolean required = false;
        String result = getNamedParameter("unique");
        if(required && result == null) {
            bomb("unique=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getValueStrategy() {
		boolean required = false;
        String result = getNamedParameter("value-strategy");
        if(required && result == null) {
            bomb("value-strategy=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTable() {
		boolean required = false;
        String result = getNamedParameter("table");
        if(required && result == null) {
            bomb("table=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getColumn();
        getDefaultFetchGroup();
        getDeleteAction();
        getDependent();
        getEmbedded();
        getFetchDepth();
        getForeignKey();
        getIndexed();
        getLoadFetchGroup();
        getMappedBy();
        getNullValue();
        getPersistenceModifier();
        getPrimaryKey();
        getSequence();
        getSerialized();
        getUnique();
        getValueStrategy();
        getTable();
    }

    public void validateModel() {
        // check uniqueness
    }
}